// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include <memory>
#include <string>
#include "ISCW_UObject.h"

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UClass;
	
	class ISCW_FImplementedInterface
	{
	public:
		virtual ~ISCW_FImplementedInterface() = default;
		
		virtual shared_ptr<ISCW_FImplementedInterface> ToFImplementedInterfacePtr() = 0;
		virtual shared_ptr<const ISCW_FImplementedInterface> ToFImplementedInterfacePtr() const = 0;

		virtual shared_ptr<ISCW_UClass> GetClass() const = 0;
	};

	using ISCW_FImplementedInterfaceConstPtr = shared_ptr<const ISCW_FImplementedInterface>;
	using ISCW_FImplementedInterfacePtr = shared_ptr<ISCW_FImplementedInterface>;
} // namespace Sourcify